using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace patterns
{
    class Book
    {
        public String Title { get; set; }
        public int Pages { get; set; }

        public override string ToString()
        {
            return string.Format("Book {0} {1}", Title, Pages);
        }
    }

    class CD
    {
        public String Title { get; set; }
        public int Volume { get; set; }

        public override string ToString()
        {
            return string.Format("CD {0} {1}", Title, Volume);
        }
    }

    class Program
    {
        public static Object Create(String className, Dictionary<String, Object> values)
        {
            Type type = Type.GetType(className);
            Object instance = Activator.CreateInstance(type);
            foreach(var entry in values) 
            {
                type.GetProperty(entry.Key).SetValue(instance, entry.Value, null);
            }

            return instance;
        }

        static void Main(string[] args)
        {
            Console.WriteLine(Create("patterns.Book", 
              new Dictionary<String, Object>() {{"Title", "Who moved my cheese"}, {"Pages", 96}}));
            Console.WriteLine(Create("patterns.CD", 
              new Dictionary<String, Object>() { { "Title", "Melody" }, { "Volume", 1 } }));
        }
    }
}
