using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace patterns
{
    class OldMail
    {
        public void to(string toAddr) { }
        public void from(string fromAddr) { }
        public void subject(string theSub) { }
        public void message(string msg) { }
        public void send() { }
    }

    class Mailer
    {
        public Mailer to(string toAddr) { return this; }
        public Mailer from(string fromAddr) { return this; }
        public Mailer subject(string theSub) { return this; }
        public Mailer message(string msg) { return this; }        public void send() { }
    }

    class Program
    {
        static void Main(string[] args)
        {
            OldMail mail = new OldMail();
            mail.from("buildr@agiledeveloper.com");
            mail.to("venkats@agiledeveloper.com");
            mail.subject("Build notification");
            mail.message("whatever...");
            mail.send();
            // lacks fluency, what do you do with
            // the mail object when you are done, can
            // you reuse it? Let's make this fluent.

            new Mailer()
              .from("buildr.agiledeveloper.com")
              .to("venkats@agiledeveloper.com")
              .subject("Build notification")
              .message("whatever...")
              .send();
        }
    }
}
