using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace patterns
{
    class Resource
    {
        protected Resource()
        {
        }

        public void op1()
        {
            Console.WriteLine("operation1...");
        }

        public void op2()
        {
            Console.WriteLine("operation2...");
        }

        private void Cleanup()
        {
            Console.WriteLine("cleanup expensive resource");
        }

        public static void Use(Action<Resource> block)
        {
            Resource resource = new Resource();
            try
            {
                block(resource);
            }
            finally
            {
                resource.Cleanup();
            }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            Resource.Use((resource) =>
                {
                    resource.op1();
                    resource.op2();
                }
            );
        }
    }
}
